#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # 2A.i - Modèle relationnel, analyse d'incidents dans le transport aérien
# 
# Base de données relationnelles, logique SQL.

# In[1]:


from jyquickhelper import add_notebook_menu
add_notebook_menu()


# ### Données
# 
# Le code suivant télécharge les données nécessaires [tp_2a_5_compagnies.zip](http://www.xavierdupre.fr/enseignement/complements/tp_2a_5_compagnies.zip).

# In[2]:


import pyensae.datasource
pyensae.datasource.download_data("tp_2a_5_compagnies.zip")


# In[3]:


import os
import pandas
df_Incident = pandas.read_csv('Incident.csv', sep=';')
df_Flights  = pandas.read_csv('Flights.csv', sep=';')
df_Crews    = pandas.read_csv('Crews.csv', sep=';')
df_Crews_planes_habilitation = pandas.read_csv('Crews_planes_habilitation.csv', sep=';')
df_Planes       = pandas.read_csv('Planes.csv', sep=';')
df_Plane_models = pandas.read_csv('Plane_models.csv', sep=';')
df_Motors       = pandas.read_csv('Motors.csv', sep=';')
df_Motor_models = pandas.read_csv('Motor_models.csv', sep=';')
df_Compagnies   = pandas.read_csv('Compagnies.csv', sep=';')
df_Cities       = pandas.read_csv('Cities.csv', sep=';')


# In[4]:


df_Incident.head(5)


# In[5]:


df_Flights.head(5)


# In[6]:


df_Crews.head(5)


# In[7]:


df_Crews_planes_habilitation.head(5)


# In[8]:


df_Planes.head(5)


# In[9]:


df_Plane_models.head(5)


# In[10]:


df_Motors.head(5)


# In[11]:


df_Motor_models.head(5)


# In[12]:


df_Compagnies.head(5)


# In[13]:


df_Cities.head(5)


# Bien sûr, toutes les informations ne sont pas dans les tables telles quelles, il faudra faire principalement des jointures et des groupby pour obtenir les informations que l'on souhaite. Pour obtenir une table contenant les vols avec une colonne "est_incident", il faut faire :

# In[14]:


import numpy as np
try:
  df_Flights.reset_index( inplace = True )
  df_Incident.reset_index( inplace = True )
except Exception:
  pass
  ## On suppose que cela vient du fait que les index ont déjà été remis à zéros
df_Flight_Incident = pandas.merge( df_Flights, df_Incident, left_on = "Id", right_on = "Flight_id", how="outer" )
df_Flight_Incident["Is_incident"] = np.isnan( df_Flight_Incident["Flight_id"] ) == False
df_Flight_Incident.head(5)


# On peut aussi faire des statistiques par ville de départ ...

# In[15]:


df_Flight_Incident.groupby( "Departure_id" )["Is_incident"].mean()


# ### Question 1 : Question préliminaires, taux d'incident
# 
# A vous de jouer. Commencer par calculer le taux d'incident global.

# In[16]:





# ### Question 2 : Calcul de taux
#   
# Calculer le taux d'incidents par :  
#   => Compagnies  
#   => Destination  
#   => Equipage  
#   => Constructeur d'appareil (Boeing, Airbus ou Bombardier)  
#   => Modèle d'appareil (A320, A380, B737, etc ...)  
#   => Moteurs  

# In[17]:





# ### Question 3 : Régression linéaire
#     
# Pouvez-vous raisonnablement faire une régression linéaire sur le nombre d'heure de l'appareil ? Du moteur ? Pourquoi ?

# In[18]:





# ### Question 4 : Iberia VS Lufthansa
#     
# Pouvez-vous dire si, toute chose égale par ailleurs, un avion d'Iberia a plus ou moins de chance d'avoir un incident qu'un avion de la Lufthansa ?

# In[19]:





# ### Question 5 : Facteurs explicatifs
#     
# Essayer de déterminer quels sont les facteurs explicatifs. Lesquels vous paraissent statistiquement significatifs ? Y-a-t-il des corrélations indirectes ? 

# In[20]: